﻿#!/usr/bin/perl -w


#  @ARGV = ("/Volumes/myDocument/Users/ni/Desktop/kuden_mails/kuden_mail_05-09-15.txt", "伊勢物語");

use strict;

use Encode;
use utf8;

my $inputfile = shift;
my $term = shift;

$term =~ s/^\-*//;

my $desktop = "$ENV{HOME}/Desktop/";
my $ct = 1;
my $resfile = $desktop . "mail-grep_res";
my $ext = ".txt";

if (-s $resfile . $ext) {
	while (-s $resfile . $ext) {
		$resfile = $desktop . "mail-grep_res" . $ct;
		$ct++;
	}
}

$resfile = $resfile . $ext;

my $outputfile = $resfile;
# open (OUT, '>:utf8', $resfile);

my @search_words = split (", *", $term);

my $i = 0;
for (@search_words) {
	$search_words[$i] = decode ("utf8", $_);
	$i++;
}

# print OUT join ("\n", @search_words);
# exit;

open (IN, '<:utf8', $inputfile) || die "Couldn't open input file $inputfile: $!";

open (OUT, '>:utf8', $outputfile) || die "Couldn't open output file $outputfile: $!";

# binmode(STDOUT, ":utf8");

my ($mail, $mail_begins, $mailtext, $time_from_to, $now);

my $separator = "=" x 40;

while (<IN>) {
	if (/^From .+@?.+ \d{2}:\d{2}:\d{2} \d{4}$|^\d+$/) {
		$mail_begins = 1;
		if ($mail) {
			($mailtext) = &process_mail ($mail, @search_words);
			if ($mailtext) {
				print OUT $mailtext, "\n$separator\n";
			}
		}
		$mail = "";
	}
	if ($mail_begins) {
		$mail .= $_;
	}
}

if ($mail) {
	($mailtext) = &process_mail ($mail, @search_words);
	if ($mailtext) {
		print OUT $mailtext, "\n$separator\n";
	}
}

`open $outputfile`;

sub process_mail {
	my $mail = shift;
#	my $options = shift;
	my @searchwords = @_;
	
	my @search_res;
	my $i = 0;
	
	for $_ (@searchwords) {
		if ($mail =~ /$_/si) {
			$search_res[$i] = 1;
		}
		else {
			$search_res[$i] = 0;
		}
		$i++;
	}
	
	foreach my $j (@search_res) {
		if ($j == 0) {
			return (0);
		}
	}
	
	return ($mail);
	
}